Distribution:	CCux
Packager:	Christian Metzen <metzench@ccux-linux.de>

Summary:	udev - a userspace implementation of devfs
Name:		udev
Version:	125
Release:	1
Epoch:		1
Provides:	udev
License:	GNU/GPL
Group:		System/Configuration/Hardware
Source0:	ftp://ftp.kernel.org/pub/linux/utils/kernel/hotplug/%{name}-%{version}.tar.bz2
Source1:	start_udev
Source2:	udev.nodes
Source3:	udev-post.init
Source4:	fw_unit_symlinks.sh
Source5:	udev-ccux-default-rules.tar.bz2
Source20:	udev.init
Patch1:		%{name}-125-alsa.patch
Patch2:		%{name}-120-nettype.patch
Patch3:		%{name}-120-nopie.patch
Patch4:		udev-125-cd.patch
URL:		http://kernel.org/pub/linux/utils/kernel/hotplug/
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	sed
BuildRequires:	flex
BuildRequires:	pam-devel
BuildRequires:	glib-devel
BuildRequires:	bison
BuildRequires:	glibc-devel
Prereq:		MAKEDEV
Requires:	MAKEDEV sed ccux-bootscripts >= 1.3.1


# Require for rpm lzma compression transition
Requires:        rpm >= 4.4.2.3-1

%define 	debug false
%define 	udev_scriptdir /lib/udev
%define 	firmwaredir /lib/firmware

%description
The udev package contains an implementation of devfs in 
userspace using sysfs and netlink.

%package -n	libvolume_id-devel
Summary: 	Static libraries and headers for libvolume_id
Group: 		Development/Libraries
Requires: 	libvolume_id = %{epoch}:%{version}-%{release}

%description -n	libvolume_id-devel
This package contains libraries and include files, 
which needed to link against libvolume_id.

%package -n	libvolume_id
Summary: 	Dynamic libraries to get volume ids
Group: 		System/Libraries

%description -n libvolume_id
This package contains the libvolume_id.so dynamic library,
which contains functions to get volume ids.

%prep
%setup -q
tar xvfj %{SOURCE5}
%patch1 -p1 -b .alsa
%patch2 -p1 -b .nettype
%patch3 -p1 -b .nopie
%patch4 -p1 -b .cd

%build
# Do not USE_LOG in udev.static, cause it causes segfaults on openlog (bug 136005)
make \
        USE_KLIBC=false \
        USE_SELINUX=false \
	USE_STATIC=true \
	STRIP="/bin/true"  \
	udevdir="/dev" \
	USE_LOG=false DEBUG=%{debug} \
	VOLUME_ID_STATIC=true \
	EXTRAS=" \
        extras/scsi_id  \
        extras/ata_id \
        extras/usb_id \
        extras/edd_id \
        extras/volume_id \
	extras/cdrom_id \
	extras/floppy \
	" all

for i in udevd \
	extras/scsi_id/scsi_id \
	extras/ata_id/ata_id \
	extras/edd_id/edd_id \
	extras/usb_id/usb_id \
	extras/cdrom_id/cdrom_id \
	extras/volume_id/vol_id \
	extras/floppy/create_floppy_devices \
	; do
	mv $i $i.static
	touch $i
done

make clean
make E='@echo' Q='@' -C extras/volume_id/lib clean

make CC="gcc $RPM_OPT_FLAGS -fpie -pie" LDFLAGS="-pie" \
        USE_KLIBC=false \
	USE_SELINUX=false \
	udevdir="/dev" \
	USE_LOG=true		\
	DEBUG=%{debug}		\
	STRIP="/bin/true"  \
	EXTRAS="	\
        extras/scsi_id  \
        extras/ata_id \
	extras/usb_id \
	extras/edd_id \
	extras/path_id \
	extras/volume_id \
	extras/cdrom_id \
	extras/floppy \
	extras/rule_generator \
	extras/firmware \
	" all

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_sbindir}

make DESTDIR=$RPM_BUILD_ROOT CC="gcc $RPM_OPT_FLAGS -fpie -pie" LDFLAGS="-pie" install \
	libdir="/%{_lib}" \
	usrlibdir="%{_libdir}" \
	EXTRAS="	\
	extras/scsi_id	\
        extras/ata_id \
	extras/usb_id \
	extras/edd_id \
	extras/path_id \
	extras/volume_id \
	extras/cdrom_id \
	extras/floppy \
	extras/rule_generator \
	extras/firmware \
	" install

# removing default installs
rm -f $RPM_BUILD_ROOT%_sysconfdir/udev/udev.rules
rm -f $RPM_BUILD_ROOT%_sysconfdir/init.d/udev
rm -f $RPM_BUILD_ROOT%_sysconfdir/hotplug.d/default/10-udev.hotplug
# creating ccux related dirs
mkdir -p $RPM_BUILD_ROOT%_sysconfdir/udev/{rules.d,makedev.d,scripts,devices}
mkdir -p $RPM_BUILD_ROOT%_sysconfdir/dev.d/{default,block}
# force relative symlinks
ln -sf ..%{udev_scriptdir}/scsi_id $RPM_BUILD_ROOT/sbin/scsi_id
ln -sf ../../%_lib/$(basename $RPM_BUILD_ROOT/%_lib/libvolume_id.so.*.*) $RPM_BUILD_ROOT%_libdir/libvolume_id.so

for i in extras/scsi_id/scsi_id \
	extras/ata_id/ata_id \
	extras/edd_id/edd_id \
	extras/usb_id/usb_id \
	extras/volume_id/vol_id \
	extras/floppy/create_floppy_devices \
 	; do
	install -m 0755 $i.static $RPM_BUILD_ROOT%{udev_scriptdir}/$(basename $i).static
done

for i in udevd ; do
	install -m 0755 $i.static $RPM_BUILD_ROOT/sbin/$i.static
done

for i in \
	etc/udev/ccux/*.rules \
	rules/packages/40-alsa.rules \
	rules/packages/64-md-raid.rules \
	rules/packages/64-device-mapper.rules \
	; do
	install -m 0644 "$i"  "$RPM_BUILD_ROOT%_sysconfdir/udev/rules.d/${i##*/}"
done

install -m 0644 udev.conf $RPM_BUILD_ROOT%_sysconfdir/udev/udev.conf

mkdir -p $RPM_BUILD_ROOT%{udev_scriptdir}/{,devices}

install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%_sysconfdir/udev/makedev.d/50-udev.nodes
install -m 0755 %{SOURCE4} $RPM_BUILD_ROOT%{udev_scriptdir}/fw_unit_symlinks.sh

# TODO : this is basically the same as the init-script
# don't know why we have this doublettes, but we keep em
# until we find out
mkdir -p $RPM_BUILD_ROOT%_datadir/udev
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT/sbin/start_udev

mkdir -p -m 0755 $RPM_BUILD_ROOT%{firmwaredir}

mkdir -p -m 0755 $RPM_BUILD_ROOT%_sysconfdir/modprobe.d
cat > $RPM_BUILD_ROOT%_sysconfdir/modprobe.d/floppy-pnp <<EOF
alias pnp:dPNP0700 floppy
EOF

mkdir -p $RPM_BUILD_ROOT%_sysconfdir/rc.d/init.d
install -m 0755 %{SOURCE3} $RPM_BUILD_ROOT%_sysconfdir/rc.d/init.d/udev-post

#FIXME - mkinitrd
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rcsysinit.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 %{SOURCE20} $RPM_BUILD_ROOT/etc/rc.d/init.d/udev
ln -sf  ../init.d/udev $RPM_BUILD_ROOT/etc/rc.d/rcsysinit.d/S10udev

# linkink files to udevadm
ln -sf  ../../sbin/udevadm $RPM_BUILD_ROOT%_bindir/udevtest
ln -sf  ../../sbin/udevadm $RPM_BUILD_ROOT%_sbindir/udevmonitor

%preun
if [ $1 = 0 -a -f %{_initrddir}/udev ]; then
	if [ -x /bin/pidof ]; then
		pid=$(/bin/pidof -c udevd)
		if [ -n "$pid" ]; then
			kill $pid
		fi
	fi
	/sbin/chkconfig --del udev
fi
if [ "$1" = 0 ]; then
	/sbin/chkconfig --del udev-post
fi
exit 0

%post
if [ "$1" -ge "1" -a -x /bin/pidof ]; then
	pid=$(/bin/pidof -c udevd)
	if [ -n "$pid" ]; then
		kill $pid
		/sbin/udevd -d
	fi
fi
/sbin/chkconfig --add udev-post
exit 0

%triggerpostun -- dev <= 0:3.12-1
if [ $2 = 0 ]; then
	if [ -x /sbin/MAKEDEV ]; then 
		/sbin/MAKEDEV null
	else
		/bin/mknod /dev/null c 1 3
	fi
	/sbin/start_udev >/dev/null 2>&1
	if [ -e /dev/mapper/control -a -x /sbin/lvm ]; then
		/sbin/lvm vgmknodes >/dev/null 2>&1
	fi
fi
exit 0

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
#FIXME
%_sysconfdir/rc.d/*
%doc COPYING README TODO ChangeLog RELEASE-NOTES docs/* 
#%attr(0755,root,root) /sbin/udevcontrol
%attr(0755,root,root) /sbin/udevd
#%attr(0755,root,root) /sbin/udevtrigger
%attr(0755,root,root) /sbin/udevsettle
%attr(0755,root,root) /sbin/start_udev
%attr(0755,root,root) /sbin/scsi_id
%attr(0755,root,root) /sbin/udevadm
%attr(0755,root,root) %{udev_scriptdir}/scsi_id
%attr(0755,root,root) %{udev_scriptdir}/ata_id
%attr(0755,root,root) %{udev_scriptdir}/edd_id
%attr(0755,root,root) %{udev_scriptdir}/usb_id
%attr(0755,root,root) %{udev_scriptdir}/vol_id
%attr(0755,root,root) %{udev_scriptdir}/cdrom_id
%attr(0755,root,root) %{udev_scriptdir}/path_id
%attr(0755,root,root) %{udev_scriptdir}/create_floppy_devices
%attr(0755,root,root) %{udev_scriptdir}/fw_unit_symlinks.sh
%attr(0755,root,root) %{udev_scriptdir}/firmware.sh
%attr(0755,root,root) %{udev_scriptdir}/rule_generator.functions
%attr(0755,root,root) %{udev_scriptdir}/write_cd_rules
%attr(0755,root,root) %{udev_scriptdir}/write_net_rules
#%attr(0755,root,root) %{_sysconfdir}/rc.d/init.d/udev-post
%attr(0755,root,root) %{_bindir}/udevtest
%attr(0755,root,root) %{_bindir}/udevinfo
%attr(0755,root,root) %{_sbindir}/udevmonitor
%attr(0755,root,root) %dir %{_sysconfdir}/udev/
%attr(0755,root,root) %dir %{_sysconfdir}/udev/rules.d/
%attr(0755,root,root) %dir /lib/udev/rules.d/
%attr(0755,root,root) %dir %{udev_scriptdir}/
%attr(0755,root,root) %dir %{udev_scriptdir}/devices/
%attr(0755,root,root) %dir %{_sysconfdir}/udev/makedev.d/

%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/udev/udev.conf
%config %attr(0644,root,root) %{_sysconfdir}/udev/rules.d/*.rules
%config %attr(0644,root,root) /lib/udev/rules.d/*.rules*
%config %attr(0644,root,root) %dir %{_sysconfdir}/udev/makedev.d/50-udev.nodes

#%config(missingok) %{_sysconfdir}/hotplug.d/default/10-udev.hotplug
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/scsi_id.config

%attr(0644,root,root) %{_sysconfdir}/modprobe.d/floppy-pnp

%dir %attr(0755,root,root) %{firmwaredir}
%attr(0644,root,root) %{_mandir}/man8/udev*.8*
%attr(0644,root,root) %{_mandir}/man7/udev*.7*
%attr(0644,root,root) %{_mandir}/man8/scsi_id*.8*
%attr(0644,root,root) %{_mandir}/man8/ata_id*.8*
%attr(0644,root,root) %{_mandir}/man8/edd_id*.8*
%attr(0644,root,root) %{_mandir}/man8/vol_id*.8*
%attr(0644,root,root) %{_mandir}/man8/path_id*.8*
%attr(0644,root,root) %{_mandir}/man8/cdrom_id*.8*
%attr(0644,root,root) %{_mandir}/man8/create_floppy_devices*.8*

# Deprecated, but keep the ownership
%ghost %dir %{_sysconfdir}/udev/scripts/
%ghost %dir %{_sysconfdir}/udev/devices/
%ghost %dir %{_sysconfdir}/dev.d/
%attr(0755,root,root) /sbin/udevd.static
#%attr(0755,root,root) /sbin/udevtrigger.static
#%attr(0755,root,root) /sbin/udevsettle.static
%attr(755,root,root) %{udev_scriptdir}/scsi_id.static
%attr(755,root,root) %{udev_scriptdir}/ata_id.static
%attr(755,root,root) %{udev_scriptdir}/edd_id.static
%attr(755,root,root) %{udev_scriptdir}/usb_id.static
%attr(755,root,root) %{udev_scriptdir}/vol_id.static
%attr(0755,root,root) %{udev_scriptdir}/create_floppy_devices.static

%files -n libvolume_id
%doc COPYING
%attr(0755,root,root) /%{_lib}/libvolume_id.so.*

%files -n libvolume_id-devel
%doc COPYING
%defattr(0644, root, root, 0755)
%{_includedir}/libvolume_id.h 
#%{_libdir}/libvolume_id.a 
%{_libdir}/libvolume_id.so
%{_libdir}/pkgconfig/libvolume_id.pc 

%changelog
* Fri Jul 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:125-1
- Version update
* Mon Jun 30 2008 Christian Metzen <metzench@ccux-linux.de> 1:124-2
- added patch to be able to write cds and dvds again
* Mon Jun 23 2008 Christian Wasem <wasem@ccux-linux.de> 1:124-1
- Version update
* Sun Jun 01 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:122-1
- Version update
* Fri Apr 11 2008 Christian Wasem <wasem@ccux-linux.de> 1:120-1
- cleaned specfile, added ccux-default-distro.tar.bz2
* Fri Mar 28 2008 Christian Wasem <wasem@ccux-linux.de> 1:119-2
- added default-rules.patch
* Mon Mar 24 2008 Christian Wasem <wasem@ccux-linux.de> 1:119-1
- version update
* Tue Mar 18 2008 Christian Wasem <wasem@ccux-linux.de> 1:118-2
- rebuild, renamed redhat.rules to ccux.rules
* Fri Dec 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 1:118-1
- Version update
* Mon Nov 26 2007 Christian Metzen <metzench@ccux-linux.de> 1:116-5
- fixed double rules file
* Mon Nov 26 2007 Christian Metzen <metzench@ccux-linux.de> 1:116-4
- rules patch
* Mon Nov 26 2007 Christian Metzen <metzench@ccux-linux.de> 1:116-3
- alsa rules / fixed permissions
* Mon Nov 26 2007 Christian Metzen <metzench@ccux-linux.de> 1:116-2
- fixed post script
* Mon Nov 26 2007 Christian Metzen <metzench@ccux-linux.de> 1:116-1
- Version update
* Sat Feb 10 2007 Karsten Brockmann <arcam@ccux-linux.de> 1:105-1
- Version update
* Tue Jan 23 2007 Christian Metzen <metzench@ccux-linux.de> 1:104-4
- small patch adjustment
* Tue Jan 23 2007 Christian Metzen <metzench@ccux-linux.de> 1:104-3
- readded WAIT_FOR_SYSFS
* Sat Jan 20 2007 Karsten Brockmann <arcam@ccux-linux.de> 1:104-2
- removed deprecated WAIT_FOR_SYSFS from 05-early-rules
* Mon Jan 15 2007 Karsten Brockmann <arcam@ccux-linux.de> 1:104-1
- Version update
* Fri Oct 27 2006 Christian Metzen <metzench@ccux-linux.de> 1:103-2
- modified ccux rules patch
* Sun Oct 22 2006 Karsten Brockmann <arcam@ccux-linux.de> 1:103-1
- Version update
- adapted rules to fit Kernel 2.6.18
* Wed Oct 03 2006 Christian Metzen <metzench@ccux-linux.de> 1:100-3
- downgrade 
* Sun Oct 01 2006 Christian Metzen <metzench@ccux-linux.de> 101-1
- Version update
* Wed Sep 27 2006 Christian Metzen <metzench@ccux-linux.de> 100-2
- fixed initscript
* Wed Sep 27 2006 Christian Metzen <metzench@ccux-linux.de> 100-1
- Version update
* Wed Sep 27 2006 Christian Metzen <metzench@ccux-linux.de> 095-1
- Version update
* Fri Aug 04 2006 Karsten Brockmann <arcam@ccux-linux.de> 079-4
- Modified rules file (added Mode 0660 for cd/dvd-writer devices)
* Sat Apr 22 2006 Christian Metzen <metzench@ccux-linux.de> 079-3
- Modified rules file
* Sat Jan 07 2006 Christian Metzen <metzench@ccux-linux.de> 079-2
- Added some requires for cleaner updates
* Thu Jan 05 2006 Christian Metzen <metzench@ccux-linux.de> 079-1
- Version update
* Thu Jan 05 2006 Christian Metzen <metzench@ccux-linux.de> 078-4
- Modified startup Script
* Mon Jan 02 2006 Christian Metzen <metzench@ccux-linux.de> 078-3
- Modified startup Script
* Mon Jan 02 2006 Christian Metzen <metzench@ccux-linux.de> 078-2
- Modified startup Script
* Mon Dec 26 2005 Christian Metzen <metzench@ccux-linux.de> 078-1
- Version update, changed build process
* Sun Sep 04 2005 Christian Metzen <metzench@ccux-linux.de> 068-1
- Version update
* Sat Jul 02 2005 Christian Metzen <metzench@ccux-linux.de> 059-1
- Version update to 059
* Mon May 23 2005 Karsten Brockmann <brockmka@rz.fh-augsburg.de> 058-1
- Version Update to 058
* Sat May 14 2005 Christian Metzen <metzench@ccux-linux.de> 057-1
- Version Update to 057
* Fri Mar 25 2005 Christian Metzen <metzench@ccux-linux.de> 056-1
- Version Update to 056
* Wed Feb 16 2005 Christian Metzen <metzench@ccux-linux.de> 053-3
- Fixed Permissions for removable Devices
* Mon Feb 14 2005 Christian Metzen <metzench@ccux-linux.de> 053-2
- Updated to new Layout Schema
* Mon Feb 14 2005 Christian Metzen <metzench@ccux-linux.de> 053-1
- Version Update to 053
* Wed Jan 19 2005 Christian Metzen <metzench@ccux-linux.de> 050-2
- Fixed Minor Bug
* Wed Jan 19 2005 Christian Metzen <metzench@ccux-linux.de> 050-1
- Version Update to 050
* Fri Nov 19 2004 Christian Metzen <metzench@ccux-linux.de> 046-1
- Initial Release
